package com.diagbot.repository;

import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.LisBillNeoDTO;
import com.diagbot.dto.NeoEntityDTO;
import com.diagbot.entity.node.Gender;
import com.diagbot.entity.node.LisSet;
import com.diagbot.entity.node.Group;
import com.diagbot.entity.relationship.LisSetGender;
import com.diagbot.entity.relationship.LisSetGroup;
import com.diagbot.util.ListUtil;
import com.diagbot.util.NeoUtil;

import java.util.*;
import java.util.stream.Collectors;

public class LisSetNode {

	public LisBillNeoDTO LisPacktoLISDTO(LisSet lisset) {

		LisBillNeoDTO lisBillNeoDTO = new LisBillNeoDTO();
		NodeInfo nodeInfo;

		LisSetGender lisSetGender = lisset.getLisSetgender();
		if (NeoUtil.isExist(lisSetGender)) {
			if (NeoUtil.isExist(lisSetGender.getGender())) {
				Gender gender = lisSetGender.getGender();
				nodeInfo = new NodeInfo();
				nodeInfo.setName(gender.getName());
				nodeInfo.setTypeval(Constants.gender);
				lisBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
			}
		}

/*
		Age age = lispack.getAge();
		if (null!=age) {
			NodeNeoDTO ageNeoDTO = new NodeNeoDTO();
			ageNeoDTO.setMin(BigDecimal.valueOf(age.getMinval()));
			ageNeoDTO.setMax(BigDecimal.valueOf(age.getMaxval()));
			ageNeoDTO.setName("年龄");
			lisBillNeoDTO.setAgeNeoDTO(ageNeoDTO);
		}

		Set<ClinicalFinding> clinicalfindings = lispack.getClinicalfindings();
		for (ClinicalFinding clinicalfinding : clinicalfindings) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(clinicalfinding.getName());
			nodeInfo.setMinval(NeoUtil.DoubletoBigDecimal(clinicalfinding.getMinval()));
			nodeInfo.setMaxval(NeoUtil.DoubletoBigDecimal(clinicalfinding.getMaxval()));
			nodeInfo.setUnit(clinicalfinding.getUnit());
			nodeInfo.setRange(clinicalfinding.getRange());
			lisBillNeoDTO.getClinicfindings().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Medicine> conflict_medicines = lispack.getConflict_medicines();
		for (Medicine conflict_medicine : conflict_medicines) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(conflict_medicine.getName());
			lisBillNeoDTO.getOralmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<AllergicMed> allergicmeds = lispack.getAllergicmeds();
		for (AllergicMed allergicmed : allergicmeds) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(allergicmed.getName());

			lisBillNeoDTO.getAllergicmeds().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Operation> operations = lispack.getOperations();
		for (Operation operation : operations) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(operation.getName());

			lisBillNeoDTO.getOperations().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Procedure> procedures = lispack.getProcedures();
		for (Procedure procedure : procedures) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(procedure.getName());
			lisBillNeoDTO.getProcedures().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<PACS> pacss = lispack.getPacs();
		for (PACS pacs : pacss) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(pacs.getName());
			lisBillNeoDTO.getPacs().add(NeoUtil.updateNodeInfo(nodeInfo));
		}

		Set<Disease> diseases = lispack.getDiseases();
		for (Disease disease : diseases) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(disease.getName());
			lisBillNeoDTO.getDisease().add(NeoUtil.updateNodeInfo(nodeInfo));
		}
		*/

		Set<LisSetGroup> lisSetGroups = lisset.getLisSetGroups();
		for (LisSetGroup lisSetGroup : lisSetGroups) {
			if (NeoUtil.isExist(lisSetGroup)) {
				if (NeoUtil.isExist(lisSetGroup.getGroup())) {
					Group group = lisSetGroup.getGroup();
					nodeInfo = new NodeInfo();
					nodeInfo.setName(group.getName());
					nodeInfo.setTypeval(Constants.group);
					lisBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
				}
			}
		}

		return lisBillNeoDTO;
	}


	/**
	 * 处理化验套餐开单合理性
	 */
	public List<BillNeoDTO> getLisBill(List<Map<String, String>> lispacktermlist, LisSetRepository lisSetRepository) {
		List<BillNeoDTO> billNeoDTOs = new ArrayList<>();
		BillNeoDTO billNeoDTO;

		LisBillNeoDTO lisBillNeoDTO;

		List<LisSet> lisSetlist;
		String lissetname;

		for (Map<String, String> lispackterm : lispacktermlist) {
			for (String term : lispackterm.keySet()) {
				billNeoDTO = new BillNeoDTO();
				lissetname = lispackterm.get(term);
				billNeoDTO.setName(term);
				billNeoDTO.setStandname(lissetname);

				lisBillNeoDTO = new LisBillNeoDTO();

				lisSetlist = lisSetRepository.findByNameIs(lissetname);

				if (ListUtil.isNotEmpty(lisSetlist)) {
					lisBillNeoDTO = LisPacktoLISDTO(lisSetlist.get(0));
				}

				billNeoDTO.setLisBillNeoDTO(lisBillNeoDTO);

				billNeoDTOs.add(billNeoDTO);
			}
		}

		return billNeoDTOs;
	}


	/**
	 * 获取化验套餐名称列表
	 */
	public List<String> getLISPackNameList(String name, Integer size, LisSetRepository lisPackRepository, BaseNodeRepository baseNodeRepository) {
		String nodename;

		List<String> lispacklist = new ArrayList<>();

		if (null == size) {
			size = 100;
		}

		List<LisSet> lisSetlist = lisPackRepository.index(name, name, size);

		if (ListUtil.isNotEmpty(lisSetlist) && lisSetlist.size() > size) {
			lisSetlist = lisSetlist.subList(0, size);
		}

		for (LisSet lisSet : lisSetlist) {
			nodename = lisSet.getName();
			if (!lispacklist.contains(nodename)) {
				lispacklist.add(nodename);
			}
		}


		return lispacklist;
	}



	/**
	 * 获取化验套餐名称列表
	 */
	public List<String> getLISPackNames(String name, Integer size, LisSetRepository lisPackRepository) {
		String nodename;

		List<String> lispacklist;

		if (null == size || size == 0) {
			size = 100000;
		}

		lispacklist = lisPackRepository.getname(size);

		return lispacklist;
	}


	/**
	 * 更新实体属性信息
	 */
	public NeoEntityDTO updateEntity(String name, Map<String, String> props, List<String> keys, LisSetRepository lisPackRepository) {
		NeoEntityDTO neoEntityDTO = new NeoEntityDTO();
		neoEntityDTO.setName(name);

		try {
			List<LisSet> lisSetres = lisPackRepository.findByNameIs(name);

			if (lisSetres != null && lisSetres.size() > 0) {
				LisSet lisSet = lisSetres.get(0);

				for (String key : props.keySet()) {
					switch (key) {
						case "最大值":
							lisSet.setMaxval(Double.parseDouble(props.get(key)));
							break;
						case "最小值":
							lisSet.setMinval(Double.parseDouble(props.get(key)));
							break;
						case "单位":
							lisSet.setUnit(props.get(key));
							break;
					}
				}

				lisSet = lisPackRepository.save(lisSet);

				neoEntityDTO = fillNeoDTO(lisSet, keys);
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		return neoEntityDTO;
	}


	private NeoEntityDTO fillNeoDTO(LisSet lisSet, List<String> keys) {
		NeoEntityDTO neoEntityDTO = new NeoEntityDTO();
		Map<String, String> props = new HashMap<>();
		String val = "";

		neoEntityDTO.setName(lisSet.getName());
		for (String key : keys) {
			switch (key) {
				case "最大值":
					val = String.format("%.2f", lisSet.getMaxval());
					break;
				case "最小值":
					val = String.format("%.2f", lisSet.getMinval());
					break;
				case "单位":
					val = lisSet.getUnit();
					break;
			}
			props.put(key, val);
		}
		neoEntityDTO.setProperty(props);

		return neoEntityDTO;
	}



	/**
	 * 根据关系名查询对应节点
	 */
	public List<?> getNodesbyRelation(LisSet lisSet, String relname) {
		List<?> nodelist =  new ArrayList<>();

		try {
			switch (relname) {
				case "实验室检查套餐名禁忌性别":
					nodelist = Arrays.asList(lisSet.getLisSetgender().getGender());
					break;
				case "实验室检查套餐名禁忌禁忌人群":
					nodelist = lisSet.getLisSetGroups().stream().map(x -> x.getGroup()).collect(Collectors.toList());
					break;
			}
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
		finally {
			return nodelist;
		}
	}


	/**
	 * 更新关系状态属性
	 */
	public void updateRelation(LisSet lisSet, String relname, Integer status, String e_name, LisSetRepository lisSetRepository) {

		try {
			switch (relname) {
				case "实验室检查名称禁忌性别":
					lisSet.getLisSetgender().setStatus(status);
					lisSetRepository.save(lisSet);
					break;
				case "实验室检查名称禁忌禁忌人群":
					lisSet.getLisSetGroups().stream().filter(x -> x.getGroup().getName()==e_name)
							.collect(Collectors.toList()).stream().forEach(y -> y.setStatus(status));
					lisSetRepository.save(lisSet);
					break;
//				case "实验室检查名称相关实验室检查套餐名":
//					lisSet.getLisnamelisSet().stream().filter(x -> x.getLisSet().getName()==e_name).
//							collect(Collectors.toList()).stream().forEach(y -> y.setStatus(status));
//					lisSetRepository.save(lisSet);
//					break;
			}
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
		finally {

		}
	}

}

